<?php
/**
*
* @package Breizh Shoutbox
* @version $Id: shout_js.php 150 16:15 16/12/2011 Sylver35 Exp $ 
* @copyright (c) 2010, 2011 Sylver35    http://breizh-portal.com
* @copyright (c) 2007 Paul Sohier
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './'; 
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include ($phpbb_root_path . 'common.' . $phpEx);
include ($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
if (!function_exists('decode_message'))
{
	include($phpbb_root_path . 'includes/functions_content.' . $phpEx);
}

// Start session management
$user->session_begin(false);
$auth->acl($user->data);
$user->setup();
$user->add_lang(array('mods/shout', 'mods/info_acp_shoutbox'));

//Disable error reporting, can be bad for our headers ;)
error_reporting(0);

// Parameters for differents shoutbox
$shout = request_var('s', -1);
if ($shout == -1) // Normal shoutbox
{
	$sort = $sort_p = $Priv = '';
	$param = '&s=-1';
	$sort_auth = 'view';
}
else if ($shout == 0) // Private shoutbox
{
	$param = '&s=0';
	$sort = $sort_p = '_priv';
	$sort_auth = 'priv';
	$Priv = '_PRIV';
}
else if ($shout == 1) // Popup shoutbox
{
	$sort = $Priv = '';
	$param = '&s=1';
	$sort_p = '_pop';
	$sort_auth = 'view';
}
$url_board = generate_board_url().'/';
// See compatibles browsers to change the display
$compatible = compatibles_browsers();
// The number of messages to display
$shout_number = ($compatible) ? $config['shout_non_ie_nr' .$sort_p] : $config['shout_ie_nr' .$sort_p];
// Display the rules
$rules = ($config['shout_rules'] && isset($config['shout_rules_' .$user->lang_name])) ? (($config['shout_rules_' .$user->lang_name]) ? 1 : 0) : 0;
// This detect what sort of style is in use, prosilver or subsilver2...
$is_prosilver = (file_exists($phpbb_root_path. 'styles/' .$user->theme['theme_path']. '/theme/shoutbox.css')) ? true : false;
// Temp of refresh for diferents users
$refresh = (($user->data['is_bot']) ? 1200 : ((!$user->data['is_registered']) ? $config['shout_temp_anonymous'] : $config['shout_temp_users']))*1000;
// Temp of inactivity for diferents users
$inactiv = (!$user->data['is_registered']) ? $config['shout_inactiv_anony'] : ($auth->acl_get('u_shout_inactiv') ? 0 : $config['shout_inactiv_member']);
$inactiv = $inactiv ? $inactiv*60/($refresh/1000) : 0;
// Real member or not
$is_user = ($user->data['user_id'] != ANONYMOUS && !$user->data['is_bot']) ? true : false;
// Title shout
$config['shout_title'] = $config['shout_title'] ? $config['shout_title'] : $user->lang['SHOUT_START'];
// Load the user's preferences
if ($is_user)
{
	list($correct, $new_sound, $error_sound, $del_sound) = explode(', ', $user->data['user_shout']);
	list($shout_bar, $shout_pagin, $shout_bar_pop, $shout_pagin_pop, $shout_bar_priv, $shout_pagin_priv) = explode(',', $user->data['user_shoutbox']);
	$new_sound = ($new_sound == '') ? $config['shout_sound_new'] : ((!$correct) ? $new_sound : '');
	$error_sound = ($error_sound == '') ? $config['shout_sound_error'] : (($error_sound == '0') ? '' : $error_sound);
	$del_sound = ($del_sound == '') ? $config['shout_sound_del'] : (($del_sound == '0') ? '' : $del_sound);
	$config['shout_bar_option']	= ($shout_bar != 'N') ? $shout_bar : $config['shout_bar_option'];
	$config['shout_bar_option_pop']	= ($shout_bar_pop != 'N') ? $shout_bar_pop : $config['shout_bar_option_pop'];
	$config['shout_bar_option_priv'] = ($shout_bar_priv != 'N') ? $shout_bar_priv : $config['shout_bar_option_priv'];
	$config['shout_pagin_option'] = ($shout_pagin != 'N') ? $shout_pagin : $config['shout_pagin_option'];
	$config['shout_pagin_option_pop'] = ($shout_pagin_pop != 'N') ? $shout_pagin_pop : $config['shout_pagin_option_pop'];
	$config['shout_pagin_option_priv'] = ($shout_pagin_priv != 'N') ? $shout_pagin_priv : $config['shout_pagin_option_priv'];
}
else
{
	if (!$user->data['is_bot'] && isset($_COOKIE[$config['cookie_name'].'_shout']))
	{
		$config['shout_sound_on'] = ($_COOKIE[$config['cookie_name'].'_shout'] == 'on') ? true : false;
	}
	$correct = $user->data['is_bot'] ? 0 : ($config['shout_sound_on'] ? 0 : 1); // No sounds for bots, they have no ears ;)
	$new_sound = $config['shout_sound_new'];
	$error_sound = $config['shout_sound_error'];
	$del_sound = $config['shout_sound_del'];
}

//JS header
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); 
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . 'GMT'); 
header('Cache-Control: no-cache, must-revalidate'); 
header('Pragma: no-cache');
header('Content-type: text/javascript; charset=UTF-8');

// Construct js file header informations
echo "/**\n* @package Breizh Shoutbox\n* @version $Id: shout_js.php 150 16:15 16/12/2011 Sylver35 Exp $\n* @copyright (c) 2010, 2011 Sylver35   http://breizh-portal.com\n**/\n";

// Construct global vars
$array_values = array('active_delete' => (($auth->acl_get('u_shout_delete') || $auth->acl_get('u_shout_delete_s')) ? '1' : '0'), 'active_info' => (($auth->acl_get('u_shout_info') || $auth->acl_get('u_shout_info_s')) ? '1' : '0'), 'active_purge' => (($auth->acl_get('u_shout_purge')) ? '1' : '0'), 'cookie_name' => $config['cookie_name'].'_', 'cookie_domain' => '; domain='.$config['cookie_domain'], 'cookie_path' => '; path='.$config['cookie_path'], 'correct_on' => (!$correct ? 'on' : 'off'), 'isGuest' => !$user->data['is_registered'], 'temps' => $refresh, 'forum_url' => $url_board, 'soundClass' => ('button_shout_sound'.(($correct == 1) ? '_off' : '')), 'titleSound' => $user->lang['SHOUT_CLICK_SOUND_'.(($correct == 0) ? 'OFF' : 'ON')], 'sound' => (($new_sound) ? 'new/'.$new_sound : ''), 'error_sound' => (($error_sound) ? 'error/'.$error_sound : ''), 'del_sound' => (($del_sound) ? 'del/'.$del_sound : ''), 'on_ver' => md5($config['shout_version_display']), 'rules_ok' => $rules, 'title_left' => sprintf($config['shout_version_url'], $config['shout_source'], $config['shout_title' .$sort]), 'title_right' => display_encrypt(), 'sort_shout' => (($shout == 0) ? 'priv' : (($shout == 1) ? 'popup' : 'normal')), 'delete_url' => (($is_user) ? append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=delete$sort$param", false) : ''), 'edit_url' => (($is_user) ? append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=edit$sort$param", false) : ''), 'lang_direction' => (($user->lang['DIRECTION'] == 'ltr') ? 'left' : 'right'), 'button_bg' => 'button_background_'.$config['shout_color_background'.(!$is_prosilver ? '_sub' : '').$sort_p], 
'width_post' => $config['shout_width_post'.(($is_prosilver)?'':'_sub').$sort_p].'px', 'print_ver' => sprintf($user->lang['SHOUTBOX_VER'], $config['shout_version']), 'print_ver_alt' => sprintf($user->lang['SHOUTBOX_VER_ALT'], $config['shout_version']), 'check_url' => append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=check$sort_p$param",false), 'view_url' => append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=view$sort_p$param",false), 'endClassBg' => (($config['shout_button_background'.$sort_p])?' button_background_'.$config['shout_color_background'.((!$is_prosilver)?'_sub':'').$sort_p] : ''), 'number_url' => append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=number$sort_p$param",false),'is_pro' => $is_prosilver, 'see_buttons' => $config['shout_see_buttons'], 'see_buttonsleft' => $config['shout_see_buttons'], 'bar_haute' => $config['shout_bar_option'.$sort_p], 'sort_pagin' => $config['shout_pagin_option'.$sort_p], 'is_user' => $is_user);
$array_auth = array('post_ok' => 'u_shout_post', 'smilies_ok' => 'u_shout_smilies', 'image_ok' => 'u_shout_image', 'color_ok' => 'u_shout_color', 'bbcode_ok' => 'u_shout_bbcode', 'chars_ok' => 'u_shout_chars', 'popup_ok' => 'u_shout_popup', 'purge_ok' => 'u_shout_purge', 'format_ok' => 'u_shout_bbcode_change', 'online_ok' => 'u_viewonline', 'priv_ok' => 'u_shout_priv');
echo "var inactivity=$inactiv,shout_number=$shout_number";
$i = $ii = 0;
foreach ($array_values as $var => $value)
{
	$value = ($i < 31) ? $value : ($value ? 1 : 0);
	echo ",$var='$value'";
	$i++;
}
foreach ($array_auth as $var => $value)
{
	$value = ($ii < 7) ? ($auth->acl_get($value) ? 1 : 0) : (($auth->acl_get($value) && $is_user) ? 1 : 0);
	echo ",$var='$value'";
	$ii++;
}
echo ";\n";

// Conctruct lang vars
$pr = array('COMMA_SEPARATOR','SHOUT_SEP','NO_AJAX','SERVER_ERR','XML_ER','JS_ERR','LINE','FILE','LOADING','MSG_DEL_DONE','NO_MESSAGE','SHOUT_PAGE','ONLY_ONE_OPEN','EDIT','SHOUT_EDIT','NO_SHOUT_EDIT','SENDING_EDIT','EDIT_DONE','CANCEL','NEXT','PREVIOUS','PURGE_PROCESS','MISSING_DIV','SHOUT_AUTO','SHOUT_EXEMPLE','SHOUT_BBCODE_SUP','SHOUT_BBCODE_SUCCESS','SHOUT_ACTION_DELETE_EXPLAIN','SHOUT_PERSO','SHOUT_ACTION_MSG','SHOUT_ACTION_MSG_ROBOT','SHOUT_OUT_TIME','SHOUT_DEL','DEL_SHOUT','NO_SHOUT_DEL','SHOUT_POST_IP','SHOUT_IP','NO_SHOW_IP_PERM','NO_SHOUT_BBCODE','SHOUT_CLICK_SOUND_ON','SHOUT_CLICK_SOUND_OFF','MESSAGE_EMPTY');
foreach ($pr as $i => $entry)
{
	$value = htmlspecialchars($user->lang[$entry]);
	echo "lang['_$entry']='$value';";
}
echo "lang['BOARD_PATH']='{$url_board}';\n";

// Prevent direct entries and exit if not enabled...
if (!$auth->acl_get('u_shout_' .$sort_auth) || !$config['shout_enable'])
{
	echo '';
	exit_handler();
}
else if (!$user->data['is_registered'])
{?>
var print_perm=ce('a');print_perm.style.cursor='pointer';print_perm.title='<?php echo $user->lang['SHOUT_CLICK_HERE'];?>';print_perm.onclick=function(){if(document.getElementById('shout_connect').style.display=='none'){sE('shout_connect',1);print_perm.title='<?php echo $user->lang['SHOUT_DIV_CLOSE'];?>';}else{sE('shout_connect',2);print_perm.title='<?php echo $user->lang['SHOUT_CLICK_HERE'];?>';};return false;};print_perm.appendChild(tn('<?php echo $user->lang['NO_POST_PERM_GUEST'];?>'));
<?php
}
else
{?>
var print_perm='<?php echo $user->lang['NO_POST_PERM'];?>';
<?php
}?>
function write_main(){
	try{var base=ce('ul');base.className='topiclist forums';base.id='base_ul';base.style.height='97%';var li=ce('li');li.style.display='block';var dl=ce('dl');dl.style.width='100%';if(on_ver!='fe570760a00225d17510d9f56524798d'){return;};var posting_form=ce('dt');posting_form.id='post_message';if(is_pro==false){if(isGuest==true){li.style.height='22px';}else{li.style.height='30px';}};li.className='button_background '+button_bg;posting_form.style.display='block';posting_form.style.padding='3px 0 3px 1px';posting_form.style.verticalAlign='middle';posting_form.height='22px';if(is_pro==true){postingWidth='100%';}else{postingWidth='99.5%';};if(post_ok==false&&sort_pagin==false){posting_form.style.cssFloat=posting_form.style.styleFloat='none';}else{posting_form.style.cssFloat=posting_form.style.styleFloat=lang_direction;};if(bar_haute==false&&sort_pagin==false&&post_ok==true){posting_form.style.width=postingWidth;}else if(post_ok==false&&sort_pagin==false){posting_form.style.width=postingWidth;}else{posting_form.style.width=postingWidth;};if(post_ok==false&&sort_pagin==true){posting_form.style.paddingLeft='60px';};var posting_box=ce('form');posting_box.id='chat_form';posting_box.style.height='auto';if(sort_pagin==true){posting_box.style.cssFloat=posting_box.style.styleFloat=lang_direction;posting_form.style.marginTop='1px';posting_form.style.width='auto';};
		<?php
		if(!$auth->acl_get('u_shout_post'))
		{ ?>
			li.style.textAlign='center';li.style.padding='3px';li.style.borderBottom='1px solid #00608F';if(sort_pagin==true){var pagin=ce('dd');pagin.id='nr';pagin.className='pagination gensmall';pagin.style.marginTop='0px';pagin.style.paddingTop='1px';pagin.style.paddingBottom='1px';pagin.style.height='auto';pagin.style.width='auto';pagin.style.cssFloat=pagin.style.styleFloat='right';pagin.style.borderLeft='0';dl.appendChild(pagin);};posting_form.appendChild(posting_box);dl.appendChild(posting_form);li.appendChild(dl);base.appendChild(li);posting_box.appendChild(print_perm);var button_sound=ce('input');button_sound.type='button';button_sound.id='iconSound';button_sound.className=soundClass+' button_shout';button_sound.style.height='18px';button_sound.style.margin='0 0 0 8px';button_sound.style.verticalAlign='bottom';button_sound.title=titleSound;button_sound.onclick=function(){if(isGuest==true){var goguest=1;}else{var goguest=0;};soundReq(goguest);};posting_box.appendChild(button_sound);posting_box.appendChild(tn(' '));
		<?php 
		}
		else
		{ ?>
			if(bar_haute==false){li.style.borderTop='1px solid #00608F';}else{li.style.borderBottom='1px solid #00608F';};posting_box.appendChild(tn(' '));i_shout=null;var i_shout=ce('input');i_shout.className='inputbox';i_shout.name=i_shout.id='chat_message';i_shout.disabled=false;i_shout.style.marginLeft='6px';i_shout.style.width=width_post;i_shout.onkeypress=function(evt){try{supp_text('chat_message');evt=(evt)?evt:event;var c=(evt.wich)?evt.wich:evt.keyCode;if(c==13){document.getElementById('user').click();evt.returnValue=false;this.returnValue=false;return false;};return true;}catch(e){handle(e);return;}};posting_box.appendChild(i_shout);posting_box.appendChild(tn(' '));var el=ce('input');el.name=el.id='user';el.value=el.defaultValue='<?php echo $user->lang['POST_MESSAGE'];?>';el.title='<?php echo $user->lang['POST_MESSAGE_ALT'];?>';el.type='button';el.className='button1 btnmain';el.onclick=function(){if(on_ver!='fe570760a00225d17510d9f56524798d'){return;};if(document.getElementById('chat_message').value==lang['_SHOUT_AUTO']||document.getElementById('chat_message').value==''){alert(lang['_MESSAGE_EMPTY']);return;}<?php if (!$auth->acl_get('u_shout_limit_post') && $config['shout_max_post_chars']) {?>if(document.getElementById('chat_message').value.length><?php echo $config['shout_max_post_chars'];?>){alert('<?php echo $user->lang['SHOUT_TOO_BIG'];?>'+document.getElementById('chat_message').value.length+'\n'+'<?php echo $user->lang['SHOUT_TOO_BIG2']; ?>'+<?php echo $config['shout_max_post_chars']; ?>);return;}<?php }?>if(isGuest==true){if(document.getElementById('shoutname').value==''){alert('<?php echo $user->lang['SHOUT_CHOICE_NAME_ERROR'];?>');return;}sE('shout_name',2);sE('shoutnameyes',2);};querynb=0;document.getElementById('Nbquery').value=querynb;try{document.getElementById('msg').style.transitionDuration='2s';if(smilies==true&&smilies_ok==true){smilies=false;iH('smilies','');sE('smilies_ul',2);sE('smilies',2);el.title='<?php echo $user->lang['SMILIES'];?>';};if(colour==true&&color_ok==true){colour=false;sE('colour_palette',2);colored.title='<?php echo $user->lang['SHOUT_COLOR'];?>';};if(chars_view==true&&chars_ok==true){chars_view=false;sE('chars_view',2);chars.title='<?php echo $user->lang['SHOUT_CHARS'];?>';};if(shout_text==true&&format_ok==true){shout_text=false;sE('shout_bbcode',2);button_text.title=lang['_SHOUT_PERSO'];};if(shout_rules==true&&rules_ok==true){shout_rules=false;sE('shout_rules',2);div_rules.title='<?php echo $user->lang['SHOUT_RULES'];?>';};this.disabled=true;sE('post_message',2);this.disabled=false;iH('msg_txt','');document.getElementById('msg_txt').appendChild(tn('<?php echo $user->lang['SENDING'];?>'));if(document.getElementById('chat_message').value==''||document.getElementById('chat_message').value==lang['_SHOUT_AUTO']){iH('msg_txt','');throw err_msg(lang['_MESSAGE_EMPTY'], true);}
			if(huit.readyState==4||huit.readyState==0){huit.open('POST','<?php echo append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=post$sort$param",false);?>',true);huit.onreadystatechange=function(){try{if(huit.readyState!=4){return;};if(huit.readyState==4){xml=huit.responseXML;if(typeof xml!='object'||on_ver!='fe570760a00225d17510d9f56524798d'){if(document.getElementById('NBerror').value<=6){last=0;clearTimeout(timer_in);setError(document.getElementById('NBerror').value);}else{play_sound(error_sound,2,false);throw err_msg(lang['_SERVER_ERR']);document.getElementById('NBerror').value=0;return;}};if(xml.getElementsByTagName('error')&&xml.getElementsByTagName('error').length!=0){err=xml.getElementsByTagName('error')[0].childNodes[0].nodeValue;iH('msg_txt','');sE('post_message',1);last=0;message(err,true);return;}else{iH('msg_txt','');document.getElementById('msg_txt').appendChild(tn('<?php echo $user->lang['POSTED'];?>'));setTimeout("iH('msg_txt','')",500);sE('post_message',1);count=0;clearTimeout(timer_in);setTimeout('last=0;reload_post();reload_page();',500);};document.getElementById('chat_message').focus();}}catch(e){handle(e);return;}};post='chat_message=';post+=encodeURIComponent(document.getElementById('chat_message').value);if(document.getElementById('user_cite').innerHTML!=''){post+='&cite=';post+=encodeURIComponent(document.getElementById('user_cite').innerHTML);};document.getElementById('chat_message').value='';document.getElementById('user_cite').innerHTML='';if(smilies==true&&smilies_ok==true){smilies=false;iH('smilies','');sE('smilies_ul',2);sE('smilies',2);el.title='<?php echo $user->lang['SMILIES'];?>';};if(colour==true&&color_ok==true){colour=false;sE('colour_palette',2);colored.title='<?php echo $user->lang['SHOUT_COLOR'];?>';};if(chars_view==true&&chars_ok==true){chars_view=false;sE('chars_view',2);chars.title='<?php echo $user->lang['SHOUT_CHARS'];?>';};if(shout_text==true&&format_ok==true){shout_text=false;sE('shout_bbcode',2);button_text.title=lang['_SHOUT_PERSO'];};if(shout_rules==true&&rules_ok==true){shout_rules=false;sE('shout_rules',2);div_rules.title='<?php echo $user->lang['SHOUT_RULES'];?>';};huit.setRequestHeader('Content-Type','application/x-www-form-urlencoded');huit.send(post);play_sound(sound,1,false);}else{throw err_msg('This should not happen, double request found!');}}catch(e){sE('post_message',3);setTimeout("iH('msg_txt','')",temps);handle(e);return;}};posting_box.appendChild(el);posting_box.appendChild(tn(' '));if(smilies_ok==true){el=ce('input');el.type='button';el.className='button_shout_smile button_shout';if(smilies==true){el.title='<?php echo $user->lang['SMILIES_CLOSE'];?>';}else{el.title='<?php echo $user->lang['SMILIES'];?>';};el.onclick=function(){try{if(smilies==true){smilies=false;iH('smilies','');sE('smilies_ul',2);sE('smilies',2);el.title='<?php echo $user->lang['SMILIES'];?>';add_text('chat_message');}else{smilies=true;sE('smilies_ul',1);sE('smilies',1);iH('smilies','<div style="text-align:center;margin:25px auto;">'+img_charge+lang['_LOADING']+'</div>');document.getElementById('smilies').appendChild(tn(''));el.title='<?php echo $user->lang['SMILIES_CLOSE'];?>';
			if(hsmilies.readyState==4||hsmilies.readyState==0){hsmilies.open('POST','<?php echo append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=smilies$param",false);?>',true);hsmilies.onreadystatechange=function(){try{if(hsmilies.readyState!=4){return;};if(hsmilies.readyState==4){xml=hsmilies.responseXML;if(typeof xml!='object'){play_sound(error_sound,2,false);throw err_msg(lang['_SERVER_ERR']);return;};if(xml.getElementsByTagName('error')&&xml.getElementsByTagName('error').length!=0){err=xml.getElementsByTagName('error')[0].childNodes[0].nodeValue;iH('smilies','');message(err,true);}else{var tmp=xml.getElementsByTagName('smilies');iH('smilies','');var nrsmil=xml.getElementsByTagName('smilnr')[0].childNodes[0].nodeValue;if(nrsmil>0){var plus=true;}else{var plus=false;}for(var i=(tmp.length-1);i>=0;i--){var inh=tmp[i];var a=ce('a');a.code=inh.getElementsByTagName('code')[0].childNodes[0].nodeValue;if(inh.getElementsByTagName('title')[0].childNodes[0].nodeValue){a.title=inh.getElementsByTagName('title')[0].childNodes[0].nodeValue;};a.style.cursor='pointer';a.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};insert_text(this.code,true,false);};var img=ce('img');img.alt=inh.getElementsByTagName('code')[0].childNodes[0].nodeValue;img.style.border=0;img.src=inh.getElementsByTagName('img')[0].childNodes[0].nodeValue;img.width=inh.getElementsByTagName('width')[0].childNodes[0].nodeValue;img.height=inh.getElementsByTagName('height')[0].childNodes[0].nodeValue;if(inh.getElementsByTagName('title')[0].childNodes[0].nodeValue){img.title=inh.getElementsByTagName('title')[0].childNodes[0].nodeValue;}else{img.title=inh.getElementsByTagName('code')[0].childNodes[0].nodeValue;};a.appendChild(img);document.getElementById('smilies').appendChild(a);document.getElementById('smilies').appendChild(tn(' '));};var a=ce('a');a.title='<?php echo $user->lang['SHOUT_MORE_SMILIES_ALT'];?>';a.id='url_more';a.style.cursor='pointer';a.style.marginBottom='5px';a.onclick=function(){shout_popup('<?php echo append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=smilies_popup$param");?>','<?php echo $config['shout_smilies_width'];?>','<?php echo $config['shout_smilies_height'];?>','smilies');};a.appendChild(tn('<?php echo $user->lang['SHOUT_MORE_SMILIES'];?>'));supp_text('chat_message');if(plus==true){document.getElementById('smilies').appendChild(tn('... '));document.getElementById('smilies').appendChild(a);document.getElementById('smilies').appendChild(tn(' '));}}}}catch(e){handle(e);return;}};hsmilies.setRequestHeader('Content-Type','application/x-www-form-urlencoded');hsmilies.send(null);}}}catch(e){handle(e);return;}};posting_box.appendChild(el);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var el=ce('input');el.type='button';el.className='button_shout_smile_no button_shout';el.title='<?php echo $user->lang['NO_SMILIES'];?>';el.onclick=function(){alert('<?php echo $user->lang['NO_SMILIES'];?>');};posting_box.appendChild(el);posting_box.appendChild(tn(' '));}
			if(color_ok==true){var colored=ce('input');colored.type='button';colored.className='button_shout_color button_shout';colored.accesskey='c';colored.name=colored.id='addbbcode10';colored.onclick=function(){try{if(colour==true){colour=false;sE('colour_palette',2);colored.title='<?php echo $user->lang['SHOUT_COLOR'];?>';add_text('chat_message');}else{colour=true;sE('colour_palette',1);colored.title='<?php echo $user->lang['SHOUT_COLOR_CLOSE'];?>';supp_text('chat_message');document.getElementById('colour_palette').appendChild(tn(' '));}}catch(e){handle(e);return;}};if(colour==true){colored.title='<?php echo $user->lang['SHOUT_COLOR_CLOSE'];?>';}else{colored.title='<?php echo $user->lang['SHOUT_COLOR'];?>';};posting_box.appendChild(colored);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var colored=ce('input');colored.type='button';colored.className='button_shout_color_no button_shout';colored.accesskey='c';colored.name=colored.id='addbbcode10';colored.title='<?php echo $user->lang['NO_SHOUT_COLOR'];?>';colored.onclick=function(){alert('<?php echo $user->lang['NO_SHOUT_COLOR'];?>');};posting_box.appendChild(colored);posting_box.appendChild(tn(' '));}
			if(chars_ok==true){var chars=ce('input');chars.type='button';chars.className='button_shout_chars button_shout';chars.name=chars.id='chars01';chars.onclick=function(){try{if(chars_view==true){chars_view=false;sE('chars_view',2);chars.title='<?php echo $user->lang['SHOUT_CHARS'];?>';add_text('chat_message');}else{chars_view=true;sE('chars_view', 1);chars.title='<?php echo $user->lang['SHOUT_CHARS_CLOSE'];?>';supp_text('chat_message');document.getElementById('chars_view').appendChild(tn(' '));}}catch(e){handle(e);return;}};if(chars_view==true){chars.title='<?php echo $user->lang['SHOUT_CHARS_CLOSE'];?>';}else{chars.title='<?php echo $user->lang['SHOUT_CHARS'];?>';};posting_box.appendChild(chars);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var chars=ce('input');chars.type='button';chars.className='button_shout_chars_no button_shout';chars.accesskey='o';chars.name=chars.id='chars01';chars.title='<?php echo $user->lang['NO_SHOUT_CHARS'];?>';chars.onclick=function(){alert('<?php echo $user->lang['NO_SHOUT_CHARS'];?>');};posting_box.appendChild(chars);posting_box.appendChild(tn(' '));}
			if(bbcode_ok==true){var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_bold button_shout';bbcode.accesskey='b';bbcode.name=bbcode.id='addbbcode0';bbcode.title='<?php echo $user->lang['SHOUT_BOLD'];?>';bbcode.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};bbstyle(0);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_italic button_shout';bbcode.accesskey='i';bbcode.name=bbcode.id='addbbcode2';bbcode.title='<?php echo $user->lang['SHOUT_ITALIC'];?>';bbcode.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};bbstyle(2);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_under button_shout';bbcode.accesskey='u';bbcode.name=bbcode.id='addbbcode4';bbcode.title='<?php echo $user->lang['SHOUT_UNDERLINE'];?>';bbcode.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};bbstyle(4);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_url button_shout';bbcode.accesskey='w';bbcode.name=bbcode.id='addbbcode8';bbcode.title='<?php echo $user->lang['SHOUT_URL'];?>';bbcode.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};bbstyle(8);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_bold_no button_shout';bbcode.title=lang['_NO_SHOUT_BBCODE'];bbcode.onclick=function(){alert(lang['_NO_SHOUT_BBCODE']);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_italic_no button_shout';bbcode.title=lang['_NO_SHOUT_BBCODE'];bbcode.onclick=function(){alert(lang['_NO_SHOUT_BBCODE']);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_under_no button_shout';bbcode.title=lang['_NO_SHOUT_BBCODE'];bbcode.onclick=function(){alert(lang['_NO_SHOUT_BBCODE']);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_url_no button_shout';bbcode.title=lang['_NO_SHOUT_BBCODE'];bbcode.onclick=function(){alert(lang['_NO_SHOUT_BBCODE']);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));}
			if(image_ok==true){var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_img button_shout';bbcode.accesskey='p';bbcode.name=bbcode.id='addbbcode6';bbcode.title='<?php echo $user->lang['SHOUT_IMAGE'];?>';bbcode.onclick=function(){if(document.getElementById('shout_user1').disabled==false){supp_text('shout_user1');form_name='formuser';text_name='shout_user1';}else{supp_text('chat_message');form_name='chat_form';text_name='chat_message';};bbstyle(6);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var bbcode=ce('input');bbcode.type='button';bbcode.className='button_shout_img_no button_shout';bbcode.title=lang['_NO_SHOUT_BBCODE'];bbcode.onclick=function(){alert(lang['_NO_SHOUT_BBCODE']);};posting_box.appendChild(bbcode);posting_box.appendChild(tn(' '));};if(sort_shout=='normal'||sort_shout=='priv'){if(popup_ok==true){var popup=ce('input');popup.type='button';popup.className='button_shout_popup button_shout';popup.title='<?php echo $user->lang['SHOUT_POP'];?>';popup.onclick=function(){shout_popup('<?php echo append_sid("{$phpbb_root_path}shout_popup.$phpEx","s=1");?>','<?php echo $config['shout_popup_width'];?>','<?php echo $config['shout_popup_height']; ?>','_popup');};posting_box.appendChild(popup);posting_box.appendChild(tn(' '));}else if(see_buttons==true){var popup=ce('input');popup.type='button';popup.className='button_shout_popup_no button_shout';popup.title='<?php echo $user->lang['NO_SHOUT_POP'];?>';popup.onclick=function(){alert('<?php echo $user->lang['NO_SHOUT_POP'];?>');};posting_box.appendChild(popup);posting_box.appendChild(tn(' '));}}
			if(purge_ok==true){var purge_r=ce('input');purge_r.type='button';purge_r.name=purge_r.id='purge_r';purge_r.className='button_shout_robot button_shout';purge_r.title='<?php echo $user->lang['SHOUT_PURGE_ROBOT_ALT'];?>';purge_r.onclick=function(){this.style.display='none';if(confirm('<?php echo $user->lang['SHOUT_PURGE_ROBOT_BOX'];?>'))purge_shout('<?php echo append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=purge_robot$sort$param");?>','purge_r');};posting_box.appendChild(purge_r);posting_box.appendChild(tn(' '));var purge=ce('input');purge.type='button';purge.name=purge.id='purge';purge.className='button_shout_purge button_shout';purge.title='<?php echo $user->lang['SHOUT_PURGE_ALT'];?>';purge.onclick=function(){this.style.display='none';if(confirm('<?php echo $user->lang['SHOUT_PURGE_BOX'];?>'))purge_shout('<?php echo append_sid("{$phpbb_root_path}ajax_shoutbox.$phpEx","m=purge$sort$param");?>','purge');};posting_box.appendChild(purge);posting_box.appendChild(tn(' '));};if(sort_shout=='normal'){if(priv_ok==true){var priv=ce('input');priv.type='button';priv.className='button_shout_priv button_shout';priv.title='<?php echo $user->lang['SHOUT_PRIV'];?>';priv.onclick=function(){shout_priv('<?php echo append_sid("{$phpbb_root_path}shout_popup.$phpEx",'s=0'); ?>');};posting_box.appendChild(priv);posting_box.appendChild(tn(' '));}};
			if(is_user==true){if(format_ok==true){var button_text=ce('input');button_text.type='button';button_text.className='button_shout_text button_shout';button_text.title=lang['_SHOUT_PERSO'];button_text.onclick=function(){if(shout_text==true){shout_text=false;sE('shout_bbcode',2);button_text.title=lang['_SHOUT_PERSO'];}else{shout_text=true;sE('shout_bbcode', 1);button_text.title='<?php echo $user->lang['SHOUT_DIV_BBCODE_CLOSE'];?>';document.getElementById('shout_bbcode').appendChild(tn(' '));}};if(shout_text==true){button_text.title='<?php echo $user->lang['SHOUT_DIV_BBCODE_CLOSE'];?>';}else{button_text.title=lang['_SHOUT_PERSO'];};posting_box.appendChild(button_text);posting_box.appendChild(tn(' '));};var button_config=ce('input');button_config.type='button';button_config.className='button_shout_config button_shout';button_config.title='<?php echo $user->lang['SHOUT_CONFIG_OPEN'];?>';button_config.onclick=function(){shout_popup('<?php echo append_sid("{$phpbb_root_path}shout_popup.$phpEx","m=config");?>','850','500','_popup');};posting_box.appendChild(button_config);posting_box.appendChild(tn(' '));}if(rules_ok==true){var div_rules=ce('input');div_rules.type='button';div_rules.className='button_shout_rules button_shout';div_rules.onclick=function(){if(shout_rules==true){shout_rules=false;sE('shout_rules',2);div_rules.title='<?php echo $user->lang['SHOUT_RULES'.$Priv];?>';}else{shout_rules=true;sE('shout_rules',1);div_rules.title='<?php echo $user->lang['SHOUT_RULES_CLOSE'];?>';document.getElementById('shout_rules').appendChild(tn(' '));}};if(shout_rules==true){div_rules.title='<?php echo $user->lang['SHOUT_RULES_CLOSE'];?>';}else{div_rules.title='<?php echo $user->lang['SHOUT_RULES'.$Priv];?>';};posting_box.appendChild(div_rules);posting_box.appendChild(tn(' '));}
			var button_online=ce('input');button_online.type='button';button_online.className='button_shout_online button_shout';button_online.title='<?php echo $user->lang['SHOUT_ONLINE'];?>';button_online.onclick=function(){if(shout_online==true){clearTimeout(timer_online);shout_online=false;sE('shout_online',2);button_online.title='<?php echo $user->lang['SHOUT_ONLINE'];?>';}else{shout_online=true;sE('shout_online',1);button_online.title='<?php echo $user->lang['SHOUT_ONLINE_CLOSE'];?>';shoutOnline();timer_online=setInterval('shoutOnline();',30000);document.getElementById('shout_online').appendChild(tn(' '));}};if(shout_online==true){button_online.title='<?php echo $user->lang['SHOUT_ONLINE_CLOSE'];?>';}else{button_online.title='<?php echo $user->lang['SHOUT_ONLINE'];?>';};posting_box.appendChild(button_online);posting_box.appendChild(tn(' '));var button_sound=ce('input');button_sound.type='button';button_sound.id='iconSound';button_sound.className=soundClass+' button_shout';button_sound.title=titleSound;button_sound.onclick=function(){if(isGuest==true){var goguest=1}else{goguest=0};soundReq(goguest);};posting_box.appendChild(button_sound);posting_box.appendChild(tn(' '));if(isGuest==true){var button_connect=ce('input');button_connect.type='button';button_connect.className='button_shout_connect button_shout';button_connect.title='<?php echo $user->lang['SHOUT_CLICK_HERE'];?>';button_connect.onclick=function(){if(document.getElementById('shout_connect').style.display=='none'){sE('shout_connect',1);button_connect.className='button_shout_connect_on button_shout';button_connect.title='<?php echo $user->lang['SHOUT_DIV_CLOSE'];?>';}else{sE('shout_connect',2);button_connect.className='button_shout_connect button_shout';button_connect.title='<?php echo $user->lang['SHOUT_CLICK_HERE'];?>';}};posting_box.appendChild(button_connect);posting_box.appendChild(tn(' '));};if(isGuest==true){var button_name=ce('input');button_name.type='button';button_name.id='iconName';button_name.className='button_shout_name button_shout';button_name.title='<?php echo $user->lang['SHOUT_CHOICE_NAME'];?>';button_name.onclick=function(){sE('shoutnameyes',2);if(document.getElementById('shout_name').style.display=='none'){sE('shout_name',1);button_name.className='button_shout_name_on button_shout';button_name.title='<?php echo $user->lang['SHOUT_DIV_CLOSE'];?>';}else{sE('shout_name',2);button_name.className='button_shout_name button_shout';button_name.title='<?php echo $user->lang['SHOUT_CHOICE_NAME'];?>';}};posting_box.appendChild(button_name);posting_box.appendChild(tn(' '));}if(bar_haute==true){posting_form.appendChild(posting_box);dl.appendChild(posting_form);li.appendChild(dl);base.appendChild(li);};if(bar_haute==true&&sort_pagin==true){var pagin=ce('dd');pagin.id='nr';pagin.style.marginTop='0px';pagin.style.padding='4px';pagin.style.cssFloat=pagin.style.styleFloat='right';pagin.style.height='auto';pagin.style.width='auto';pagin.style.border='0';pagin.className='pagination gensmall';dl.appendChild(pagin);}
		<?php 
		} ?>
		var msg_txt=ce('div');msg_txt.id='msg_txt';msg_txt.appendChild(tn(''));base.appendChild(msg_txt);var d_shout=document.getElementById('shout1');var t_shout=document.getElementById('shout2');if(lang_direction=='right'){t_shout.style.styleFloat=t_shout.style.cssFloat='left';t_shout.style.paddingLeft='10px';}else{t_shout.style.styleFloat=t_shout.style.cssFloat='right';t_shout.style.paddingRight='10px';}if(!t_shout||!d_shout){throw err_msg(lang['MISSING_DIV']);};d_shout.innerHTML=title_left;t_shout.innerHTML=title_right;var post=ce('div');post.style.display='block';post.id='msg';post.style.width='99.9%';post.style.overflowX='hidden';<?php $message=$user->lang['LOADING'];if($user->lang['SHOUT_COPY'] !== base64_decode('PGEgaHJlZj0iJTEkc21vZC1icmVpemgtc2hvdXRib3gtZjIxLmh0bWwiPiUyJHM8L2E+') || $user->lang['SHOUTBOX'] !== base64_decode('PGEgaHJlZj0iJTEkc2luZGV4Lmh0bWwiPiUyJHM8L2E+')){$message='';};if($compatible && $message){echo'post.style.height=\''.(($shout == -1) ? $config['shout_height'] : ($config['shout_non_ie_height'.$sort_p])). 'px\';'."post.style.overflowY='auto';";}else if(!$compatible && $message){echo"post.style.height='auto';"."post.style.overflowY='hidden';";}else{echo"post.style.height='auto'"."post.style.overflowY='hidden';";}?>
		post.innerHTML='<div style="text-align:center;margin:50px auto;">'+img_charge+'<?php echo htmlspecialchars($message);?></div>';post.appendChild(tn(''));base.appendChild(post);if(bar_haute==false&&post_ok==true){posting_form.appendChild(posting_box);dl.appendChild(posting_form);if(sort_pagin==true){var pagin=ce('dd');pagin.id='nr';pagin.className='pagination';pagin.style.marginTop='0px';pagin.style.padding='8pt 4pt 4pt';pagin.style.height='auto';pagin.style.width='auto';pagin.style.verticalAlign='middle';pagin.style.backgroundImage='none';pagin.style.marginRight='3pt';pagin.style.cssFloat=pagin.style.styleFloat='right';pagin.style.borderLeft='0';dl.appendChild(pagin);}li.appendChild(dl);base.appendChild(li);};if(sort_pagin==false||post_ok==false&&sort_pagin==false){var pagindiv=ce('div');var paginul=ce('ul');paginul.className='topiclist forums';paginul.style.margin='0';var pagin=ce('li');pagin.id='nr';pagin.className='button_background '+button_bg+' pagination';pagin.style.textAlign=lang_direction;pagin.style.margin='0';pagin.style.padding='3pt 0pt 2pt';pagin.style.height='16px';pagin.style.width='100%';pagindiv.style.height='22px';pagindiv.id='divnr';paginul.appendChild(pagin);pagindiv.appendChild(paginul);base.appendChild(pagindiv);};div.innerHTML='';div.appendChild(base);if(!t_shout||!d_shout){throw err_msg(lang['MISSING_DIV']);};if(on_ver=='fe570760a00225d17510d9f56524798d'){reload_post();reload_page();}
	}catch(e){handle(e);return;}
}